diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 54e66fac3..21bccd4cd 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -310,8 +310,8 @@ public class BlockModelDispatcher
         addDispatch(new StandardBlockModel<>(Blocks.PRESSURE_PLATE_PLANKS_OAK).withTextures("minecraft:block/planks_oak").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
         addDispatch(new StandardBlockModel<>(Blocks.PRESSURE_PLATE_COBBLE_STONE).withTextures("minecraft:block/cobbled_stone").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
 
-        addDispatch(new MotionSensorBlockModel(Blocks.MOTION_SENSOR_IDLE).withTextures("minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_idle_front", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side"));
-        addDispatch(new MotionSensorBlockModel(Blocks.MOTION_SENSOR_ACTIVE).withTextures("minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_active_front", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side"));
+        addDispatch(new MotionSensorBlockModel(Blocks.MOTION_SENSOR_IDLE).withTextures("minecraft:block/motionsensor_idle_front", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side"));
+        addDispatch(new MotionSensorBlockModel(Blocks.MOTION_SENSOR_ACTIVE).withTextures("minecraft:block/motionsensor_active_front", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side"));
 
         addDispatch(new RepeaterBlockModel(Blocks.REPEATER_IDLE).withTextures("minecraft:block/repeater_idle_top", "minecraft:block/polished_stone_top"));
         addDispatch(new RepeaterBlockModel(Blocks.REPEATER_ACTIVE).withTextures("minecraft:block/repeater_active_top", "minecraft:block/polished_stone_top").withOverbrightTexture("minecraft:block/repeater_active_overlay"));
@@ -333,7 +333,8 @@ public class BlockModelDispatcher
 
         addDispatch(new SpikesBlockModel<>(Blocks.SPIKES).withTextures("minecraft:block/spikes_top", "minecraft:block/spikes_bottom", "minecraft:block/spikes_side"));
 
-        addDispatch(new HorizontalRotationBlockModel<>(Blocks.DISPENSER_COBBLE_STONE).withTextures("minecraft:block/dispenser_top", "minecraft:block/dispenser_top", "minecraft:block/dispenser_front", "minecraft:block/dispenser_side", "minecraft:block/dispenser_side", "minecraft:block/dispenser_side"));
+        addDispatch(new VeryRotatableBlockModel<>(Blocks.DISPENSER_COBBLE_STONE).withTextures("minecraft:block/dispenser_front", "minecraft:block/dispenser_top", "minecraft:block/dispenser_side"));
+        addDispatch(new ActivatorBlockModel(Blocks.ACTIVATOR_COBBLE_NETHERRACK).withTextures("minecraft:block/activator_front", "minecraft:block/activator_top", "minecraft:block/activator_side"));
 
         addDispatch(new TrapDoorBlockModel<>(Blocks.TRAPDOOR_PLANKS_OAK).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/trapdoor_planks_oak_side"));
         addDispatch(new TrapDoorBlockModel<>(Blocks.TRAPDOOR_IRON).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/trapdoor_iron_side"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/EmptyBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/EmptyBlockModel.java
index 19e20201c..0ebe57995 100644
--- a/src/main/java/net/minecraft/client/render/block/model/EmptyBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/EmptyBlockModel.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 
 public class EmptyBlockModel extends StandardBlockModel<Block> {
@@ -19,6 +21,11 @@ public class EmptyBlockModel extends StandardBlockModel<Block> {
 
     }
 
+    @Override
+    public IconCoordinate getParticleTexture(Side side, int meta) {
+        return null;
+    }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/src/main/java/net/minecraft/client/render/block/model/HorizontalRotationBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/HorizontalRotationBlockModel.java
index 6187733eb..c79954cad 100644
--- a/src/main/java/net/minecraft/client/render/block/model/HorizontalRotationBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/HorizontalRotationBlockModel.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.RotatableBlock;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
@@ -13,7 +14,7 @@ public class HorizontalRotationBlockModel<T extends Block> extends StandardBlock
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data, 5) + side.getId()];
+        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & RotatableBlock.MASK_DIRECTION, 5) + side.getId()];
         if (index >= Sides.orientationLookUpHorizontal.length) return atlasIndices[0];
         return atlasIndices[index];
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
index 2401550df..34929a8f3 100644
--- a/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
@@ -3,10 +3,11 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.FullRotatableBlock;
 import net.minecraft.core.block.MotionSensorBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class MotionSensorBlockModel extends HorizontalRotationBlockModel<MotionSensorBlock> {
+public class MotionSensorBlockModel extends VeryRotatableBlockModel<MotionSensorBlock> {
     protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/motionsensor_overlay");
     public MotionSensorBlockModel(Block block) {
         super(block);
@@ -17,7 +18,7 @@ public class MotionSensorBlockModel extends HorizontalRotationBlockModel<MotionS
     {
         if (!block.isActive) return null;
 
-        if(side.getId() == data)
+        if(side.getId() == FullRotatableBlock.metaToDirection(data).getSide().getId())
         {
             return overlay;
         }
diff --git a/src/main/java/net/minecraft/client/render/block/model/TorchRedstoneBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/TorchRedstoneBlockModel.java
index 7b65a424e..de07d508e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/TorchRedstoneBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TorchRedstoneBlockModel.java
@@ -24,4 +24,9 @@ public class TorchRedstoneBlockModel extends TorchBlockModel<RedstoneTorchBlock>
             return super.getBlockTextureFromSideAndMetadata(side, data);
         }
     }
+
+    @Override
+    public IconCoordinate getParticleTexture(Side side, int meta) {
+        return atlasIndices[Side.NORTH.getId()];
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/VeryRotatableBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/VeryRotatableBlockModel.java
new file mode 100644
index 000000000..57c6fcf51
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/VeryRotatableBlockModel.java
@@ -0,0 +1,49 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.VeryRotatableEntityBlock;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
+
+public class VeryRotatableBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public VeryRotatableBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        final Direction dir = VeryRotatableEntityBlock.metaToDirection(meta);
+
+        if (dir == Direction.DOWN || dir == Direction.UP) {
+            renderBlocks.uvRotateSouth = 1;
+            renderBlocks.uvRotateNorth = 2;
+        }
+        final boolean result = renderStandardBlock(tessellator, block, x, y, z);
+        resetRenderBlocks();
+
+        return result;
+    }
+
+
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderBlockOnInventory(tessellator, 3, brightness, alpha, lightmapCoordinate);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    {
+        final Direction dir = VeryRotatableEntityBlock.metaToDirection(data);
+        if (side == dir.getSide()) {
+            return atlasIndices[Side.TOP.getId()];
+        }
+        if (side == Side.BOTTOM || side == Side.TOP) return atlasIndices[Side.BOTTOM.getId()];
+        if ((dir.getSide() == Side.BOTTOM || dir.getSide() == Side.TOP) && (side == Side.NORTH || side == Side.SOUTH)) return atlasIndices[Side.BOTTOM.getId()];
+        return side.getDirection() != dir.getOpposite() ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/blockentity/MeshBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/MeshBlockEntityRenderer.java
index 2ce9fc9c6..4b832d2ee 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/MeshBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/MeshBlockEntityRenderer.java
@@ -11,12 +11,15 @@ import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.MathHelper;
+import java.util.Random;
 import org.lwjgl.opengl.GL12;
 
 public class MeshBlockEntityRenderer extends BlockEntityRenderer<GoldMeshBlockEntity> {
 	
 	public ItemEntity renderEntity = new ItemEntity(null);
-	
+
+    private Random rand = new Random();
+
     @Override
     public void doRender(Tessellator tessellator, GoldMeshBlockEntity tileEntity, double x, double y, double z, float renderPartialTicks) {
         if(tileEntity.filterItem == null) return;
@@ -37,7 +40,7 @@ public class MeshBlockEntityRenderer extends BlockEntityRenderer<GoldMeshBlockEn
         BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glEnable(GL11.GL_BLEND);
-        ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderAsItemEntity(Tessellator.instance, renderEntity, tileEntity.worldObj.rand, tileEntity.filterItem, 1, f3, lightLevel, renderPartialTicks);
+        ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderAsItemEntity(Tessellator.instance, renderEntity, rand, tileEntity.filterItem, 1, f3, lightLevel, renderPartialTicks);
         GL11.glDisable(GL11.GL_BLEND);
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glPopMatrix();
diff --git a/src/main/java/net/minecraft/core/block/ActivatorBlock.java b/src/main/java/net/minecraft/core/block/ActivatorBlock.java
new file mode 100644
index 000000000..60a44ff0c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/ActivatorBlock.java
@@ -0,0 +1,138 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class ActivatorBlock extends VeryRotatableEntityBlock
+{
+    public static final int MASK_POWERED = 0b0000_1000;
+    public ActivatorBlock(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, Material.netherrack);
+    }
+
+    @Override
+    public int tickDelay()
+    {
+        return 4;
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
+    {
+        if (!world.isClientSide) {
+            ActivatorBlockEntity dispenserBlockEntity = (ActivatorBlockEntity) world.getBlockEntity(x, y, z);
+            player.displayActivatorScreen(dispenserBlockEntity);
+        }
+        return true;
+    }
+
+    private void useItem(World world, int x, int y, int z, Random random)
+    {
+        Direction direction = RotatableBlock.getDirectionFromMeta(world.getBlockMetadata(x, y, z));
+        int xOffset = direction.getOffsetX();
+        int yOffset = direction.getOffsetY();
+        int zOffset = direction.getOffsetZ();
+
+        ActivatorBlockEntity activator = (ActivatorBlockEntity)world.getBlockEntity(x, y, z);
+        if (!activator.locked(activator.stackSelector)) {
+            ItemStack itemStack = activator.getNextStack();
+
+            double px = (double)xOffset * 0.6D + 0.5D;
+            double py = (double)yOffset * 0.6D + 0.5D;
+            double pz = (double)zOffset * 0.6D + 0.5D;
+            if(itemStack == null)
+            {
+                Block block = world.getBlock(x + xOffset, y + yOffset, z + zOffset);
+                if (block != null) {
+                    block.onActivatorInteract(world, x + xOffset, y + yOffset, z + zOffset, activator, direction);
+                } else {
+                    world.playBlockEvent(LevelListener.EVENT_DISPENSER_EMPTY, x, y, z, 0);
+                }
+            }
+            else
+            {
+                Item item = itemStack.getItem();
+                item.onUseByActivator(itemStack, activator, world, random, x, y, z, px, py, pz, direction);
+                activator.nullDeadItems();
+                world.playBlockEvent(LevelListener.EVENT_DISPENSER_PARTICLES, x, y, z, direction.getId());
+            }
+        } else {
+            activator.shiftSelector();
+        }
+    }
+
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    {
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean flag = getNeighborSignal(world, x, y, z, RotatableBlock.getDirectionFromMeta(meta));
+        if(flag && (meta & MASK_POWERED) == 0)
+        {
+            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+            world.setBlockMetadata(x, y, z, meta | MASK_POWERED);
+        } else if (!flag){
+            world.setBlockMetadata(x, y, z, meta & ~MASK_POWERED);
+        }
+    }
+
+    @Override
+    public void updateTick(World world, int x, int y, int z, Random rand)
+    {
+        if(getNeighborSignal(world, x, y, z, RotatableBlock.getDirectionFromMeta(world.getBlockMetadata(x, y, z))))
+        {
+            useItem(world, x, y, z, rand);
+        }
+    }
+
+    private boolean getNeighborSignal(World world, int x, int y, int z, Direction direction) {
+        if(direction != Direction.DOWN && world.getSignal(x, y - 1, z, Side.BOTTOM)) {
+            return true;
+        }
+        if(direction != Direction.UP && world.getSignal(x, y + 1, z, Side.TOP)) {
+            return true;
+        }
+        if(direction != Direction.NORTH && world.getSignal(x, y, z - 1, Side.NORTH)) {
+            return true;
+        }
+        if(direction != Direction.SOUTH && world.getSignal(x, y, z + 1, Side.SOUTH)) {
+            return true;
+        }
+        if(direction != Direction.EAST && world.getSignal(x + 1, y, z, Side.EAST)) {
+            return true;
+        }
+        if(direction != Direction.WEST && world.getSignal(x - 1, y, z, Side.WEST)) {
+            return true;
+        }
+        if(world.getSignal(x, y, z, Side.BOTTOM)) {
+            return true;
+        }
+        if(world.getSignal(x, y + 1, z - 1, Side.NORTH)) {
+            return true;
+        }
+        if(world.getSignal(x, y + 1, z + 1, Side.SOUTH)) {
+            return true;
+        }
+        if(world.getSignal(x - 1, y + 1, z, Side.WEST)) {
+            return true;
+        }
+        return world.getSignal(x + 1, y + 1, z, Side.EAST);
+    }
+
+    @Override
+    protected BlockEntity getNewBlockEntity()
+    {
+        return new ActivatorBlockEntity();
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/block/AlgaeBlock.java b/src/main/java/net/minecraft/core/block/AlgaeBlock.java
index 8d1a21c09..733f29bd5 100644
--- a/src/main/java/net/minecraft/core/block/AlgaeBlock.java
+++ b/src/main/java/net/minecraft/core/block/AlgaeBlock.java
@@ -30,7 +30,7 @@ public class AlgaeBlock extends Block
     {
         if(entity instanceof BoatEntity) {
             int data = world.getBlockMetadata(x, y, z);
-            world.playSoundEffect(null, 2001, x, y, z, id);
+            world.playBlockEvent(null, 2001, x, y, z, id);
             world.setBlockWithNotify(x, y, z, 0);
             this.onBlockRemoved(world, x, y, z, data);
         }
diff --git a/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java b/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
index 07cc04736..fde1697f2 100644
--- a/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
+++ b/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
@@ -6,6 +6,7 @@ import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class AxisAlignedBlock extends Block {
 
@@ -14,7 +15,7 @@ public class AxisAlignedBlock extends Block {
 	}
 
 	@Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
 		Axis axis = mob.getPlacementDirection(side, PlacementMode.SIDE).getAxis();
 		
 		world.setBlockMetadataWithNotify(x, y, z, axisToMeta(axis));
diff --git a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
index 44fe14a60..2da2ab76f 100644
--- a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
@@ -12,6 +12,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.season.Season;
+import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, IBlockAccess, Material
@@ -214,7 +215,7 @@ public abstract class BaseLeavesBlock extends Block
     }
     
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
     	return LeavesLayerBlock.MASK_PERMANENT;
     }
     
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index c019e3bf9..e362db9e7 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -9,8 +9,10 @@ import java.util.Random;
 import java.util.function.Function;
 import java.util.function.Supplier;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.util.helper.Direction;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -552,6 +554,10 @@ public class Block
         return false;
     }
 
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+
+    }
+
     public void onEntityWalking(World world, int x, int y, int z, Entity entity)
     {
     }
@@ -675,7 +681,7 @@ public class Block
         return true;
     }
 
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
 
     }
 
@@ -716,7 +722,7 @@ public class Block
         return blockMaterial.getPushReaction();
     }
     
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
     {
     	return 0;
     }
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 3842e3af3..353dacc8c 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -313,6 +313,7 @@ public final class Blocks {
     public static Block SPIKES;
 
     public static Block DISPENSER_COBBLE_STONE;
+    public static Block ACTIVATOR_COBBLE_NETHERRACK;
 
     public static Block TRAPDOOR_PLANKS_OAK;
     public static Block TRAPDOOR_IRON;
@@ -973,7 +974,7 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         PISTON_BASE_STICKY = new StickyPistonBaseBlock("piston.base.sticky", "minecraft:block/piston_base_sticky", 521, 12).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        PISTON_HEAD = new PistonHeadBlock("piston.head", "minecraft:block/piston_head", 522, 4/16d).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats()
+        PISTON_HEAD = new PistonHeadBlock("piston.head", "minecraft:block/piston_head", 522, 4/16d).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats().withImmovableFlagSet()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
         PISTON_MOVING = new MovingPistonBlock("piston.moving", "minecraft:block/piston_moving", 523).withSound(BlockSounds.STONE).withDisabledStats()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU);
@@ -997,6 +998,8 @@ public final class Blocks {
 
         DISPENSER_COBBLE_STONE = new DispenserBlock("dispenser.cobble.stone", "minecraft:block/dispenser_cobble_stone", 560).withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        ACTIVATOR_COBBLE_NETHERRACK = new ActivatorBlock("activator.cobble.netherrack", "minecraft:block/activator_cobble_netherrack", 561).withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         TRAPDOOR_PLANKS_OAK = new TrapDoorBlock("trapdoor.planks.oak", "minecraft:block/trapdoor_planks_oak", 570, Material.wood).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE);
diff --git a/src/main/java/net/minecraft/core/block/BrazierBlock.java b/src/main/java/net/minecraft/core/block/BrazierBlock.java
index 998713d28..ffa7a1a0c 100644
--- a/src/main/java/net/minecraft/core/block/BrazierBlock.java
+++ b/src/main/java/net/minecraft/core/block/BrazierBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
@@ -7,6 +8,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.FireStrikerItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
@@ -63,6 +65,13 @@ public class BrazierBlock
         return false;
     }
 
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        if (burning) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id, 0);
+        }
+    }
+
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
         if (burning) {
diff --git a/src/main/java/net/minecraft/core/block/ButtonBlock.java b/src/main/java/net/minecraft/core/block/ButtonBlock.java
index dd5884682..c6d345cb4 100644
--- a/src/main/java/net/minecraft/core/block/ButtonBlock.java
+++ b/src/main/java/net/minecraft/core/block/ButtonBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -7,10 +8,13 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -84,7 +88,7 @@ public class ButtonBlock extends Block
     }
     
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         int i1 = world.getBlockMetadata(x, y, z);
         int j1 = i1 & 8;
         i1 &= 7;
@@ -225,6 +229,10 @@ public class ButtonBlock extends Block
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
+        return press(world, x, y, z, player);
+    }
+
+    public boolean press(World world, int x, int y, int z, @Nullable Player player) {
         int l = world.getBlockMetadata(x, y, z);
         int i1 = l & 7;
         int j1 = 8 - (l & 8);
@@ -253,6 +261,11 @@ public class ButtonBlock extends Block
         return true;
     }
 
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        press(world, x, y, z, null);
+    }
+
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
